/***************************************************************************
           ibdatabase.h  -  ibasepp   ; 
                             -------------------
    begin                : Fri May 5 2000
    copyright            : (C) 2000 by Vadim Morgunov
    email                : vvm@kis.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef IBDATABASE_H
#define IBDATABASE_H

#include <string>
#include <map>

extern "C" {
#include <ibase.h>
#include <stdlib.h>
}

#include "ibexception.h"
#include "ibasepp_common.h"

using namespace std;

/***************************************************************************
    ibase
 ***************************************************************************/

class IBDatabase {
public: //   
	 IBDatabase();
   IBDatabase( const char* DBName );
   IBDatabase( const char* DBName, const char* User, const char* Password,
               const char* CharSet = "win1251" );
	~IBDatabase();
public:
  typedef map<int, const char*, less<int> > DBParamMap;
public: //fields
   DBParamMap Params;
public: //methods	
  const bool isActive();
  void setDBName(const char* DBName);
  const char* getDBName();
  const unsigned short getSQLDialect();
  void setSQLDialect(const unsigned short Dialect);
  void open();
  void close();
  isc_db_handle* getDBHandle(); 	
private: // fields
  bool _Connected;
  string _DBName;
  isc_db_handle _Handle;
  unsigned short _Dialect;
private:
  void connect();
  void disconnect();
  const short setDPB(char** dpb_buffer);
};

#endif
