/***************************************************************************
            ibeventcontainer.h  -    ibasepp
                             -------------------
    begin                : Thu May 18 2000
    copyright            : (C) 2000 by Vadim Morgunov
    email                : vvm@kis.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef IBEVENTCONTAINER_H
#define IBEVENTCONTAINER_H

extern "C" {
#include <ibase.h>
}

#include "ibdatabase.h"
#include "ibexception.h"
#include "ibasepp_common.h"

class IBEventContainer;

isc_callback event_func (IBEventContainer* event, short length, char* updated);

/***************************************************************************
    ibasepp
 ***************************************************************************/

class IBEventContainer {
public:
  IBEventContainer(IBDatabase* DBase);
  virtual ~IBEventContainer();
public:
  const short getCount() { return (_Count + 1); };

  const bool add(const char* EventName);
  void remove(const char* EventName);
  const bool isExists(const char* EventName);

  void start();
  void stop();
  int check();
protected:
  virtual int execute(IBDatabase* DBase, const char* EventName, ISC_LONG count) = 0;
private:
  char* _EventNames[15];
  char* _EventBuf;
  char* _ResultBuf;
  ISC_LONG _EventId;
  ISC_LONG _BLength;
  int      _Flag;
  bool     _First;
  IBDatabase* _DBase;
  short    _Count;
private:
  friend isc_callback event_func(IBEventContainer* event, short length, char* updated);
};

#endif
