/***************************************************************************
        ibexception.cpp  -    ibasepp; 
                             -------------------
    begin                : Fri May 5 2000
    copyright            : (C) 2000 by Vadim Morgunov
    email                : vvm@kis.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ibexception.h"

#define EXCPT_FORMAT  "\n\nIBASEPP ERROR:\n %s\nin file: %s at line: %d.\n"

IBException::IBException(const char* source, const int line,
  const char* message)
{
  _what = formatStr( EXCPT_FORMAT, message, source, line );
}

IBException::IBException(const char* source, const int line, long* pvector) {
  string tmp;
  char *msg = new char[256];
  long *p = pvector;

  memset(msg, 0, 256);
  isc_interprete(msg, &p);
  tmp = msg; *msg = '-'; tmp += "\n";
  while( isc_interprete(msg + 1, &p) ){
   tmp += msg; tmp +="\n";
 }
 delete[] msg;
 _what = formatStr( EXCPT_FORMAT, tmp.c_str(), source, line );
}

const char* IBException::formatStr(const char* format, ...) {
  if( format == NULL  ) return NULL;
  int n, size = 50;
  char* p;
  va_list ap;

  p = (char*)malloc(size);
  while( 1 ) {
    memset(p, 0, size);
    va_start(ap, format);
    n = vsnprintf(p, size, format, ap);
    va_end(ap);
    if( n > -1 && n < size ) break;
    if( n > -1 ) size += 1;
    else size *= 2;
    p = (char*)realloc(p, size);
  }
  return p;
}
