/***************************************************************************
              ibtransaction.h  -    SQL
                             -------------------
    begin                : Fri May 5 2000
    copyright            : (C) 2000 by Vadim Morgunov
    email                : vvm@kis.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef IBTRANSACTION_H
#define IBTRANSACTION_H

#include <vector>

extern "C" {
#include <ibase.h>
#include <stdlib.h>
}

#include "ibexception.h"
#include "ibdatabase.h"
#include "ibasepp_common.h"


using namespace std;

/***************************************************************************
     ibasepp
 ***************************************************************************/

class IBTransaction {
public: //   
  IBTransaction();
	IBTransaction( IBDatabase* DBase );
	~IBTransaction();
public: // fields
  typedef vector<const char*> TRParamVec;
public: // methods
  void setDatabase( IBDatabase* DBase );
  IBDatabase* getDatabase();
  void clearParams();
  void setParam(const char* tpb_param);
  void startTransaction();
  void commit();
  void rollback();
  void commitRetaining();
  void rollbackRetaining();
  const bool isActive();
  isc_tr_handle* getTRHandle();
private: //fields
  isc_tr_handle _Handle;
  IBDatabase* _DBase;
  bool _Active;
  TRParamVec _Params;
private:
  const unsigned short setTPB( char** tpb_buffer );
  void setDefaultTPB();
};

#endif
