/***************************************************************************
                       ibxsqlda.h  -   SQL
                             -------------------
    begin                : Wed May 10 2000
    copyright            : (C) 2000 by Vadim Morgunov
    email                : vvm@kis.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef IBXSQLDA_H
#define IBXSQLDA_H

#include <vector>

extern "C" {
#include <ibase.h>
#include <string.h>
#include <stdlib.h>
}

extern "C++" {
#include <vector>
#include <algorithm>
}

#include "ibexception.h"
#include "ibxsqlvar.h"
#include "ibasepp_common.h"

using namespace std;

class IBCheckField {
public:
  IBCheckField( const char* checkStr ): _CondStr(checkStr) {};
public:
  bool operator()( IBXSQLVAR* var ) {
    if( _CondStr == NULL ) return false;
    return strcasecmp( var->getName(), _CondStr ) == 0;
  }
private:
  const char* _CondStr;
};

class IBQuery; // . ibquery.h

/***************************************************************************
     ibasepp
 ***************************************************************************/

class IBXSQLDA {
public:
  IBXSQLDA();
  IBXSQLDA(IBQuery* query);
  ~IBXSQLDA();
public: //mehtods
  IBXSQLVAR& operator[](const int Index);
  IBXSQLVAR& operator[](const char* FieldName);
  IBXSQLVAR& getByIndex(const int Index);
  IBXSQLVAR& getByName(const char* FieldName);
  void setQuery(IBQuery* query);
  const IBQuery* getQuery();
  XSQLDA* getAsXSQLDA();
  void setAsXSQLDA(XSQLDA* sqlda);
  const int getCount();
  void setCount(const unsigned int cnt);
  void allocateSqlData();
  IBXSQLVAR* createIBXSQLVAR( const unsigned int FieldIndex );
private:
  typedef IBXSQLVAR* PIBXSQLVAR;
  typedef vector<PIBXSQLVAR> FieldVec;
private: // fields
  XSQLDA* _Sqlda;
  FieldVec _Vars;
  IBQuery*  _Query;
};

#endif
