/***************************************************************************
                    main.cpp  -     ibasepp
                             -------------------
    begin                :   26 15:02:11 MSD 2000
    copyright            : (C) 2000 by Vadim Morgunov
    email                : vvm@kis.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream.h>
#include <stdlib.h>
#include "ibasepp.h"

//        
const char* DB_NAME   = "/usr/interbase/examples/employee.gdb";
const char* USER_NAME = "sysdba";
const char* PASSWORD  = "masterkey";

const char* EMPLOYEE_LIST_SQL =
  "select *                   \
     from employee            \
     where job_country = :country \
     order by full_name";

//  
void print_record( IBQuery* qr );

int main(int argc, char *argv[])
{
  IBDatabase    db;
  IBTransaction tr;
  IBQuery       qr;

  cout << "IBasepp test program. (C) Morgunov V. 2000" << endl;

  try {
//   
    db.setDBName( DB_NAME );
    db.Params[ isc_dpb_user_name ] = USER_NAME;
    db.Params[ isc_dpb_password  ] = PASSWORD;
//    
    db.open();
    if( db.isActive() ) {
//   
      tr.setDatabase( &db );
      tr.clearParams();
      tr.setParam( "concurrency" );
      tr.setParam( "nowait" );
      tr.setParam( "no_rec_version" );
//  
      tr.startTransaction();
      if( tr.isActive() ) {
//  SQL
        qr.setTransaction( &tr );
        qr.setSQL( EMPLOYEE_LIST_SQL );
//  SQL  
        qr.prepare();
//   
        qr.Params["country"] = "USA";
//  
        qr.execQuery();
        while( !qr.isEOF() ) {
//  
          print_record( &qr );
//   . 
          qr.next();
        }
        if( qr.isActive() ) qr.close();
//  
        tr.commit();
      }
//  
      db.close();
    }
  } catch( IBException& e ) {
    cerr << e.what() << endl;
    exit(1);
  }

  return EXIT_SUCCESS;
}
//--------------------------------------------------------------------------
void print_record( IBQuery* qr ) {
  if( qr == 0 ) return;
  char buf[33];
  unsigned int length = 0;
//    
  for( int i = 0; i < qr->Fields.getCount(); i++  )
    if( strlen(qr->Fields[i].getName()) > length )
      length = strlen(qr->Fields[i].getName());
//  <_> : <>
  for( int i = 0; i < qr->Fields.getCount(); i++ ) {
    memset(buf, 0, 33);
    snprintf(buf, 32, "%*s", length, qr->Fields[i].getName());
    cout << buf << " : " << flush;
    cout << qr->Fields[i] << endl;
  }
  cout << endl;
}
